/* jshint esversion : 6 */


const { typeOf } = require('app_get_typeof');


function superStringify(a) {

    if (a == null || "undefined" === typeof a)
        return a;
    else if ("array" === typeOf(a))
        return '[' + a.map(e => superStringify(e)).join() + ']';
    else if ("object" === typeOf(a)) {
        let doStringify = true;
        const ov = Object.values(a);
        for (let i = 0; i < ov.length; i++) {

            if (["string", "number", "null", "undefined", "boolean"].indexOf(typeOf(ov[i])) === -1) {
                doStringify = false;
                break;
            } else
                continue;
        }
        if (doStringify)
            return JSON.stringify(a);
        else {
            for (let k in a) {
                a[k] = superStringify(a[k]);
            }
            return JSON.stringify(a);
        }
    } else if ("function" === typeOf(a))
        return a.toString().replace(/\s{2,}|\n+|\r+/g, "");
    else if ("date" === typeOf(a))
        return a.toString();
    else
        return a;
}

exports.superStringify = a => superStringify(a).replace(/\\+/gi, '');

exports.areEquals = function(a, b, opt) {
    if (typeOf(a) !== typeOf(b))
        return false;
    else if ("array" === typeOf(a) && a.length !== b.length)
        return false;
    else if ("object" === typeOf(a) && Object.keys(a).join() !== Object.keys(b).join())
        return false;
    else {


        if (Array.isArray(a) && Array.isArray(b) && opt) {
            const _setArrayCompare = x => Object.entries(opt).reduce((curr, [fnName, fn]) => {
                if (Array.isArray(fn))
                    return fn.reduce((curr, next) => curr[fnName](next), curr);

                return curr[fnName](fn);
            }, x);

            a = superStringify(_setArrayCompare(a));
            b = superStringify(_setArrayCompare(b));

        } else {
            a = superStringify(a);
            b = superStringify(b);
        }

        return a === b;
    }
};